import oscP5.*;
import netP5.*;
import ddf.minim.analysis.*;
import ddf.minim.*;
import ddf.minim.signals.*;
 
Minim minim;
AudioPlayer jingle;
AudioInput out;
AudioInput input;
FFT fft;
String windowName;

OscP5 oscP5;
NetAddress myRemoteLocation;

PImage hintergrund;
PImage a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17;
PImage b1, b2, b3, b4, b5, b6, b5a, b7;
PImage auge1, auge2, auge3;

float xWert = 0, yWert = 30;
float auge1l_sizeX = 50, auge1l_sizeY = 50, auge1r_sizeX = 50, auge1r_sizeY = 50;
float auge2l_sizeX = 130, auge2l_sizeY = 130, auge2r_sizeX = 130, auge2r_sizeY = 130;
float breite = 1, hoehe = 1;
PImage lidZahl;
float sensitivity = 1;
int rsensitivity;
float ton1, ton2, ton3, ton4, ton1s=1, ton2s=1, ton3s=1, ton4s=1;

PImage blinzeln;
boolean blinzelt = false;
float blinzelGenerator;
int blinzelSekunde = 0;
float nichtBlinzeln = 1;

boolean mode2 = false;
float mode2f = 0.5;
int darstellungA, darstellungB, darstellungC;
int mouseXOld, mouseYOld;


// SETUP
void setup() {
  size(1200, 750);
  frameRate(25);
  noCursor();

  hintergrund = loadImage("hg.png");
  a1 = loadImage ("a1b.png");
  a2 = loadImage ("a2b.png");
  a3 = loadImage ("a3b.png");
  a4 = loadImage ("a4b.png");
  a5 = loadImage ("a5b.png");
  a6 = loadImage ("a6b.png");
  a7 = loadImage ("a7b.png");
  a8 = loadImage ("a8b.png");
  a9 = loadImage ("a9b.png");
  a10 = loadImage ("a10b.png");
  a11 = loadImage ("a11b.png");
  a12 = loadImage ("a12b.png");
  a13 = loadImage ("a13b.png");
  a14 = loadImage ("a14b.png");
  a15 = loadImage ("a15b.png");
  a16 = loadImage ("a16b.png");
  a17 = loadImage ("a17b.png");
  b1 = loadImage ("a1.png");
  b2 = loadImage ("b2b.png");
  b3 = loadImage ("b3b.png");
  b4 = loadImage ("b4b.png");
  b5 = loadImage ("a12.png");
  b6 = loadImage ("a12.png");
  b5a = loadImage ("a15.png");
  auge1 = loadImage ("auge1.png");
  auge2 = loadImage ("auge2.png");
  auge3 = loadImage ("auge3.jpg");
  lidZahl = a9;
  blinzeln = b2;
  
  minim = new Minim(this);
  out = minim.getLineIn(Minim.STEREO, 2048);
  fft = new FFT(out.bufferSize(), out.sampleRate());

  oscP5 = new OscP5(this, 12000);
  myRemoteLocation = new NetAddress("127.0.0.1", 12000);
  
  blinzelt = true;
  blinzeln = b1;
}





// D R A W D R A W D R A W D R A W D R A W D R A W D R A W
void draw() {
  
  
  if (mode2f < 0.5){
    mode2 = true;
  }
  else {
    mode2 = false;
  }

  background(255);
  imageMode(CENTER);

  // EYE BACKGROUND
  image (auge3, width/2-240+xWert, height/2+yWert*0.8, 450, 450);
  image (auge3, width/2+250+xWert, height/2+yWert*0.8, 450, 450);

  // IRIS
    breite = -0.00005*sq(xWert)+1;
    hoehe = -0.000008*sq(yWert)+1;
    
  if (mode2 == true) {  
    tint (255-ton3*30*sensitivity,255-ton2*50*sensitivity,255-ton1*50*sensitivity);
    ton1s = map (ton1s,1,1.2, 1,1.04);
    ton3s = map (ton3s,1,2, 1,1.1);
  }
    
  image (auge2, width/2-240+xWert, height/2+yWert*0.8, breite*auge2r_sizeX*ton1s, hoehe*auge2r_sizeY*ton1s);
 
 if (mode2 == true) {  
    tint (255-ton4*0*sensitivity,255-ton1*50*sensitivity,255-ton2*50*sensitivity);
    ton2s = map (ton2s,1,1.2, 1,1.04);
    ton4s = map (ton4s,1,2, 1,1.1);
  }
  
  image (auge2, width/2+250+xWert, height/2+yWert*0.8, breite*auge2r_sizeX*ton2s, hoehe*auge2r_sizeY*ton2s);
  
  if (mode2 == true) {  
    tint (255,255,255);
  }

  // PUPIL
  image (auge1, width/2-240+xWert, height/2+yWert*0.8, breite*auge1l_sizeX*ton3s, hoehe*auge1l_sizeY*ton3s); 
  image (auge1, width/2+250+xWert, height/2+yWert*0.8, breite*auge1r_sizeX*ton4s, hoehe*auge1r_sizeY*ton4s);


  image(hintergrund, width/2, height/2);

  // LID
   if (yWert <100) {lidZahl = a17;} 
   if (yWert <90) {lidZahl = a16;} 
   if (yWert <78) {lidZahl = a15;} 
   if (yWert <66) {lidZahl = a14;}
   if (yWert <54) {lidZahl = a13;}
   if (yWert <42) {lidZahl = a12;}
   if (yWert <30) {lidZahl = a11;}
   if (yWert <18) {lidZahl = a10;} 
   if (yWert <6) {lidZahl = a9;}
   if (yWert <-6) {lidZahl = a8;}
   if (yWert <-18) {lidZahl = a7;}
   if (yWert <-30) {lidZahl = a6;}
   if (yWert <-42) {lidZahl = a5;} 
   if (yWert <-54) {lidZahl = a4;}
   if (yWert <-66) {lidZahl = a3;}
   if (yWert <-78) {lidZahl = a2;}
   if (yWert <-90) {lidZahl = a1;}
  
  if (blinzelt == false) {  
  image (lidZahl, width/2, height/2+12);}

  //println(xWert + " " + yWert + " " +frameRate);
    
  // BLINK
  
  if (blinzelt == false) {
  if (blinzelGenerator <99) {
    blinzelGenerator = random (100);
  }
  else {
    blinzelt = true;}}
  
  if(blinzelt == true) {
    
  if (blinzeln == b6){blinzeln = b2;}  
  if (blinzeln == b5a){blinzeln = b2;}
  if (blinzeln == b5){blinzeln = b6;blinzelt = false; blinzelGenerator = 1;}
  if (blinzeln == b4){
    if (yWert < 40) {
    blinzeln = b5;}
    else {
    blinzeln = b5a; blinzelt = false; blinzelGenerator = 1;}
  }
  if (blinzeln == b3){blinzeln = b4;}
  if (blinzeln == b2){blinzeln = b3;}
  if (blinzeln == b1){blinzeln = b2;}
    
  image (blinzeln, width/2, height/2+12);
  }



  // EQUALIZER



  fft.forward(out.mix);  
  ton1 = fft.getBand(5)*sensitivity;
  ton2 = fft.getBand(15)*sensitivity;
  ton3 = fft.getBand(30)*sensitivity;
  ton4 = fft.getBand(40)*sensitivity;
  
  //println (ton1 + " " + ton2 + " " + ton3 + " " + ton4);
  
  ton1s = map (ton1, 0,2, 1,1.2);
  ton2s = map (ton2, 0,3, 1,1.2);
  ton3s = map (ton3, 0,3, 1,2);
  ton4s = map (ton4, 0,5, 1,2);

  if (nichtBlinzeln > 120) {
    nichtBlinzeln = 1;
  }
  
  println(nichtBlinzeln);
  
  if (nichtBlinzeln < 1.5) {
  if (ton1s > 2) {
    blinzelGenerator = 99.5;
    nichtBlinzeln = 100;
  }
  }
  
  if (nichtBlinzeln > 99) {
  nichtBlinzeln = nichtBlinzeln + 1;
  }
  
  
  // MOUSE CONTROL, TEXT  
  if (mouseXOld != mouseX) {
  xWert = map (mouseX, 0, width, -100, 100);}
  
  if (mouseYOld != mouseY) {
  yWert = map (mouseY, 0, height, -100, 100);}
  
  mouseXOld = mouseX;
  mouseYOld = mouseY;
  
  textSize(40);
  textAlign(CENTER);
  
   if (darstellungA > 5) {
   if (darstellungB < 1) {
   if (darstellungC < 1) {  
   darstellungA = darstellungA +1;
   text("Color Mode", width/2, height-50);
   }}}
   if (darstellungA > 30) {
   darstellungA = 0;
   }
  
   if (darstellungB > 5) {
   if (darstellungA < 1) {
   if (darstellungC < 1) {
   darstellungB = darstellungB +1;
   text("Size Mode", width/2, height-50);
   }}}
   if (darstellungB > 30) {
   darstellungB = 0;
   }  
   
   if (darstellungC > 5) {
   if (darstellungA < 1) {
   if (darstellungB < 1) {
   darstellungC = darstellungC +1;
   rsensitivity = round(sensitivity*10);
   text("Sensitivity: " + rsensitivity, width/2, height-50);
   }}}
   if (darstellungC > 30) {
   darstellungC = 0;
   }  
  
  
  
// D R A W    E N D S

println(mode2);

}

void stop()
{
  out.close();
  minim.stop(); 
  super.stop();
}


// K E Y B O A R D
void keyPressed () {
   if (key == ' '){
     if (mode2f > 0){
       mode2f= 0;
       darstellungA = 10;
       darstellungB = 0;
       darstellungC = 0;
   }
     else {
       mode2f = 1;
       darstellungB = 10;
       darstellungA = 0;
       darstellungC = 0;
     }}
   
   
   if (key == '+') {
     sensitivity = sensitivity + 0.1;
     darstellungC = 10;
     darstellungB = 0;
     darstellungA = 0;
   }
   if (key == '-') {
     if (sensitivity > 0) {
       sensitivity = sensitivity -0.1;
       darstellungC = 10;
       darstellungB = 0;
       darstellungA = 0;}
   }
 }

// O S C 


void oscEvent(OscMessage touchField) {
  
  String addr = touchField.addrPattern();
  float val = touchField.get(0).floatValue();
  if (addr.equals("/1/fader2")){ sensitivity = val; }
  if (addr.equals("/1/toggle2")){ mode2f = val; }

  float xValue = touchField.get(0).floatValue();
  float yValue = touchField.get(1).floatValue();

  xWert = xValue;
  yWert = yValue;
}

